## com.crystaldecisions.report.web.viewer
Class CrystalReportViewer

    java.lang.Object
      com.crystaldecisions.report.web.ServerControl
          com.crystaldecisions.report.web.viewer.ReportServerControl
              com.crystaldecisions.report.web.viewer.CrystalReportViewerBase
                  com.crystaldecisions.report.web.viewer.CrystalReportViewer

public class CrystalReportViewer
extends CrystalReportViewerBase

This class enables you to manipulate how the viewer is displayed. As well as methods to add listeners for specific events within the displayed report, there are methods for setting various options concerning how the report is displayed.

Field Summary
`static java.lang.String` | `PAGE_TYPE` Specifies view type to be rendered as `Page`
`static java.lang.String` | `TOOLBAR_TYPE` Specifies view type to be rendered as `Toolbar`
`static java.lang.String` | `TREE_TYPE` Specifies view type to be rendered as `GroupTree`

Fields inherited from class com.crystaldecisions.report.web.viewer.CrystalReportViewerBase
`BACKWARD, FORWARD, NOACTION`

Constructor Summary
`CrystalReportViewer()` Constructs the `CrystalReportViewer` object.

Method Summary
`void` | `addDrillDownSubreportEventListener(DrillDownSubreportEventListener listener)` Adds a listener for `DrillDownSubreportEvents`.
`void` | `addNavigateEventListener(NavigateEventListener listener)` Adds a listener for `NavigateEvents`.
`void` | `addToolbarCommandEventListener(ToolbarCommandEventListener listener)` Adds a listener for `ToolbarCommandEvents`.
`void` | `drillDown(IGroupPath groupPath, java.lang.String groupName)` Drills down on the report.
`int` | `getGroupTreeWidth()` Returns the current width of the group tree.
`CrHtmlUnitEnum` | `getGroupTreeWidthUnit()` Returns whether pixels or percentage is being used to determine the group tree width.
`double` | `getPageToTreeRatio()` Deprecated. Use `getGroupTreeWidth()` and `getGroupTreeWidthUnit()` instead.
`CrPrintMode` | `getPrintMode()` Returns the current print mode that will be used when the user clicks the print button.
`Toolbar` | `getToolbar()` Returns the toolbar object.
`ViewInfo` | `getViewInfo()` Returns the `ViewInfo` object.
`int` | `getZoomFactor()` Returns the zoom factor that is currently set.
`boolean` | `hasExportButton()` Returns whether the report viewer has an export button.
`boolean` | `hasGotoPageButton()` Returns whether the report viewer has a "Go to Page" button.
`boolean` | `hasLogo()` Returns whether the report viewer is set to display the Crystal Decisions logo.
`boolean` | `hasPageNavigationButtons()` Returns whether the report viewer has page navigation buttons.
`boolean` | `hasPrintButton()` Returns whether the report viewer has a print button.
`boolean` | `hasRefreshButton()` Returns whether the report viewer has a refresh button.
`boolean` | `hasSearchButton()` Returns whether the report viewer has a search button.
`boolean` | `hasToggleGroupTreeButton()` Returns whether the report viewer has a button for toggling the display of the group tree.
`boolean` | `hasViewList()` Returns whether the report viewer has a view list.
`boolean` | `hasZoomFactorList()` Returns whether the report viewer has a zoom factor list.
`boolean` | `isBestFitPage()` Returns whether the viewer will ignore the height and width values it is given and try to find the best fit for the report by taking up as much space as it needs to properly display the report.
`boolean` | `isDisplayGroupTree()` Returns whether the group tree is displayed.
`boolean` | `isDisplayPage()` Returns whether the report page is displayed.
`boolean` | `isDisplayToolbar()` Returns whether the toolbar is displayed.
`boolean` | `isEnableDrillDown()` Returns whether the user can drill down on the report.
`boolean` | `isRenderAsHTML32()` Returns whether the report is rendered as HTML 3.2.
`boolean` | `isSeparatePages()` Returns whether the report is displayed as separate pages or one long page.
`boolean` | `isShowAllPageIds()` Returns whether `PageIds` are added to the HTML content.
`void` | `removeDrillDownSubreportEventListener()` Removes a `DrillDownSubreportEventListener`.
`void` | `removeNavigateEventListener()` Removes a `NavigateEventListener`.
`void` | `removeToolbarCommandEventListener()` Removes a `ToolbarCommandEventListener`.
`void` | `searchText(java.lang.String strTextToSearch, int searchDirection)` Highlights the first occurrence of the specified text in the report and scrolls to it.
`void` | `setBestFitPage(boolean bestFitPage)` Sets whether the viewer will ignore the height and width values it is given and try to find the best fit for the report by taking up as much space as it needs to properly display the report.
`void` | `setDisplayGroupTree(boolean newM_bDisplayGroupTree)` Sets whether to display the group tree.
`void` | `setDisplayPage(boolean newM_bDisplayPage)` Sets whether to display the report page.
`void` | `setDisplayToolbar(boolean display)` Sets whether to display the toolbar.
`void` | `setEnableDrillDown(boolean enableDrillDown)` Sets whether to enable drill down.
`void` | `setGroupTreeWidth(int newGroupTreeWidth)` Sets the width of the group tree.
`void` | `setGroupTreeWidthUnit(CrHtmlUnitEnum newGroupTreeWidthUnit)` Sets whether to use pixels or percentage to determine the group tree width.
`void` | `setHasExportButton(boolean newM_bHasExportButton)` Sets whether to display the export button.
`void` | `setHasGotoPageButton(boolean newM_bHasGotoPageButton)` Sets whether to display the `GotoPageButton`.
`void` | `setHasLogo(boolean newM_bHasLogo)` Sets whether to display the Crystal Decisions logo.
`void` | `setHasPageNavigationButtons(boolean newM_bHasPageNavigationButtons)` Sets whether to display the page navigation buttons.
`void` | `setHasPrintButton(boolean newM_bHasPrintButton)` Sets whether to display the print button.
`void` | `setHasRefreshButton(boolean newM_bHasRefreshButton)` Sets whether to display the refresh button.
`void` | `setHasSearchButton(boolean newM_bHasSearchButton)` Sets whether to display the search button.
`void` | `setHasToggleGroupTreeButton(boolean newM_bHasToggleButton)` Sets whether to display the toggle group tree button.
`void` | `setHasViewList(boolean newM_bHasViewList)` Sets whether to display the view list.
`void` | `setHasZoomFactorList(boolean newM_bHasZoomButton)` Sets whether to display a zoom factor list.
`void` | `setPageToTreeRatio(double newM_nPageToTreeRatio)` Deprecated. Use `setGroupTreeWidth(int)` and `setGroupTreeWidthUnit(com.crystaldecisions.report.web.viewer.CrHtmlUnitEnum)` instead.
`void` | `setPrintMode(CrPrintMode printMode)` Sets whether to print using PDF or ActiveX print mode when the user clicks the print button.
`void` | `setRenderAsHTML32(boolean newM_bRenderAsHTML32)` Sets whether to render the content as HTML 3.2.
`void` | `setSeparatePages(boolean separate)` Sets whether the report is displayed as separate pages or one long page.
`void` | `setShowAllPageIds(boolean showAllPageIds)` Sets whether `PageIds` are added to the HTML content.
`void` | `setZoomFactor(int newM_ZoomFactor)` Sets a new zoom factor for displaying the report.
`void` | `showFirstPage()` Displays the first page of the report.
`void` | `showLastPage()` Displays the last page of the report.
`void` | `showNextPage()` Displays the next page of the report.
`void` | `showNthPage(int pageNumber)` Displays the specified page of the report.
`void` | `showPreviousPage()` Displays the previous page of the report.

Methods inherited from class com.crystaldecisions.report.web.viewer.CrystalReportViewerBase
`addAfterRenderContentEventListener, addAfterRenderEventListener, addAfterRenderObjectEventListener, addAfterRenderViewItemEventListener, addBeforeRenderContentEventListener, addBeforeRenderEventListener, addBeforeRenderObjectEventListener, addBeforeRenderViewItemEventListener, addDrillEventListener, addOnRenderScriptEventListener, addOnRenderStyleEventListener, getHyperlinkTarget, removeAfterRenderContentEventListener, removeAfterRenderEventListener, removeAfterRenderObjectEventListener, removeAfterRenderViewItemEventListener, removeBeforeRenderContentEventListener, removeBeforeRenderEventListener, removeBeforeRenderObjectEventListener, removeBeforeRenderViewItemEventListener, removeDrillEventListener, removeOnRenderScriptEventListener, removeOnRenderStyleEventListener, setHyperlinkTarget`

Methods inherited from class com.crystaldecisions.report.web.viewer.ReportServerControl
`addReportPartBookmarkNavigationEventListener, addReportSourceChangeEventListener, dispose, getDatabaseLogonInfos, getEnterpriseLogon, getParameterFields, getReportSource, getReportSourceClassFactoryName, getSelectionFormula, getStyleSheetFileName, isEnableLogonPrompt, isEnableParameterPrompt, isReuseParameterValuesOnRefresh, navigateTo, refresh, removeReportPartBookmarkNavigationEventListener, removeReportPartBookmarkNavigationEventListenerr, removeReportSourceChangeEventListener, setDatabaseLogonInfos, setEnableLogonPrompt, setEnableParameterPrompt, setEnterpriseLogon, setParameterFields, setReportSource, setReportSourceClassFactoryName, setReuseParameterValuesOnRefresh, setSelectionFormula, setStyleSheetFileName, setURI, setViewTimeSelectionFormula`

Methods inherited from class com.crystaldecisions.report.web.ServerControl
`deserializeBase64ToObject, getHeight, getHtmlContent, getLeft, getName, getTop, getURI, getViewState, getWidth, isIgnoreViewStateOnLoad, isOwnForm, isOwnPage, processHttpRequest, setHeight, setIgnoreViewStateOnLoad, setLeft, setName, setOwnForm, setOwnPage, setTop, setViewState, setWidth`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### TOOLBAR_TYPE

    public static final java.lang.String TOOLBAR_TYPE

  Specifies view type to be rendered as `Toolbar`

  See Also:
    Constant Field Values

### TREE_TYPE

    public static final java.lang.String TREE_TYPE

  Specifies view type to be rendered as `GroupTree`

  See Also:
    Constant Field Values

### PAGE_TYPE

    public static final java.lang.String PAGE_TYPE

  Specifies view type to be rendered as `Page`

  See Also:
    Constant Field Values

Constructor Detail

### CrystalReportViewer

    public CrystalReportViewer()

  Constructs the `CrystalReportViewer` object.

Method Detail

### addDrillDownSubreportEventListener

    public void addDrillDownSubreportEventListener(DrillDownSubreportEventListener listener)
                                            throws java.util.TooManyListenersException

  Adds a listener for `DrillDownSubreportEvents`.

  Parameters:
    `listener` - The `DrillDownSubreportEventListener`.
  Throws:
    `java.util.TooManyListenersException` - This is thrown if you attempt to add more than one listener on a particular listener source concurrently.
  See Also:
    `removeDrillDownSubreportEventListener`

### addNavigateEventListener

    public void addNavigateEventListener(NavigateEventListener listener)
                                  throws java.util.TooManyListenersException

  Adds a listener for `NavigateEvents`.

  Parameters:
    `listener` - The `NavigateEventsListener`.
  Throws:
    `java.util.TooManyListenersException` - This is thrown if you attempt to add more than one listener on a particular listener source concurrently.
  See Also:
    `removeNavigateEventListener`

### addToolbarCommandEventListener

    public void addToolbarCommandEventListener(ToolbarCommandEventListener listener)
                                        throws java.util.TooManyListenersException

  Adds a listener for `ToolbarCommandEvents`.

  Parameters:
    `listener` - The `ToolbarCommandEventListener`.
  Throws:
    `java.util.TooManyListenersException` - This is thrown if you attempt to add more than one listener on a particular listener source concurrently.
  See Also:
    `removeToolbarCommandEventListener`

### drillDown

    public void drillDown(IGroupPath groupPath,
                          java.lang.String groupName)

  Drills down on the report.

  Parameters:
    `groupPath` - An `IGroupPath` object that specifies the path of the group to drill down on.
    `groupName` - A `String` that specifies the name of the group to drill down on.

### getGroupTreeWidth

    public int getGroupTreeWidth()

  Returns the current width of the group tree. This value can be either be specified in pixels or as a percentage, depending on the value returned by `getGroupTreeWidthUnit()`.

  Returns:
    An `int` specifying the current width of the group tree.

### getGroupTreeWidthUnit

    public CrHtmlUnitEnum getGroupTreeWidthUnit()

  Returns whether pixels or percentage is being used to determine the group tree width.

  Returns:
    A `CrHtmlUnitEnum` object specifying the unit being used to determine group tree width.
  See Also:
    `CrHtmlUnitEnum`

### getPageToTreeRatio

    public double getPageToTreeRatio()

  Deprecated. Use `getGroupTreeWidth()` and `getGroupTreeWidthUnit()` instead.

  Returns the page-to-tree ratio. This indicates the percentage of the report viewer that will be used to display the page as compared to the tree.

  Note: The default value for the ratio is 3, which indicates that the page takes up 3 times more space than the tree, or 75 percent of the space.

  Returns:
    The page-to-tree ratio as a `double`.
  See Also:
    `setPageToTreeRatio`

### getToolbar

    public Toolbar getToolbar()

  Returns the toolbar object.

  Note: This method is provided so that you can see the default toolbar in case you want to modify it.

  Returns:
    The toolbar object.

### getViewInfo

    public ViewInfo getViewInfo()

  Returns the `ViewInfo` object. The `ViewInfo` object is used to obtain information for the client that is not available from the specific listener that is being used.

  For example, if you were using the event handler for the `NavigateEventListener`, you could use the following to access the group name from the `ViewInfo` object: ``

       public void navigate (NavigateEvents e) {
       	String groupName = ((CrystalReportViewer) (e.getSource()).getViewInfo().getGroupName();
       }

  Returns:
    The `ViewInfo` object.

### getZoomFactor

    public int getZoomFactor()

  Returns the zoom factor that is currently set.

  Returns:
    The zoom factor as an `int`.
  See Also:
    `hasZoomFactorList`, `setHasZoomFactorList`, `setZoomFactor`

### hasExportButton

    public boolean hasExportButton()

  Returns whether the report viewer has an export button.

  Returns:
    `true` if the viewer has an export button and `false` otherwise.
  See Also:
    `setHasExportButton`

### hasGotoPageButton

    public boolean hasGotoPageButton()

  Returns whether the report viewer has a "Go to Page" button.

  Returns:
    `true` if the viewer has a "Go to Page" button and `false` otherwise.
  See Also:
    `setHasGotoPageButton`

### hasLogo

    public boolean hasLogo()

  Returns whether the report viewer is set to display the Crystal Decisions logo.

  Returns:
    `true` if the viewer is set to display the Crystal Decisions logo and `false` otherwise.
  See Also:
    `setHasLogo`

### hasPageNavigationButtons

    public boolean hasPageNavigationButtons()

  Returns whether the report viewer has page navigation buttons.

  Returns:
    `true` if the viewer has page navigation buttons and `false` otherwise.
  See Also:
    `setHasPageNavigationButtons`

### hasPrintButton

    public boolean hasPrintButton()

  Returns whether the report viewer has a print button.

  Returns:
    `true` if the viewer has a print button and `false` otherwise.
  See Also:
    `setHasPrintButton`

### hasRefreshButton

    public boolean hasRefreshButton()

  Returns whether the report viewer has a refresh button.

  Returns:
    `true` if the viewer has a refresh button and `false` otherwise.
  See Also:
    `setHasRefreshButton`

### hasSearchButton

    public boolean hasSearchButton()

  Returns whether the report viewer has a search button.

  Returns:
    `true` if the viewer has a search button and `false` otherwise.
  See Also:
    `setHasSearchButton`

### hasToggleGroupTreeButton

    public boolean hasToggleGroupTreeButton()

  Returns whether the report viewer has a button for toggling the display of the group tree.

  Returns:
    `true` if the viewer has group tree button and `false` otherwise.
  See Also:
    `setHasToggleGroupTreeButton(boolean newM_bHasToggleButton)`

### hasViewList

    public boolean hasViewList()

  Returns whether the report viewer has a view list.

  Returns:
    `true` if the viewer has a view list and `false` otherwise.
  See Also:
    `setHasViewList`

### hasZoomFactorList

    public boolean hasZoomFactorList()

  Returns whether the report viewer has a zoom factor list.

  Returns:
    `true` if the viewer has a zoom factor list and `false` otherwise.
  See Also:
    `getZoomFactor`, `setHasZoomFactorList`, `setZoomFactor`

### isBestFitPage

    public boolean isBestFitPage()

  Returns whether the viewer will ignore the height and width values it is given and try to find the best fit for the report by taking up as much space as it needs to properly display the report.

  Returns:
    `true` if the viewer will try to find the best fit for the report, otherwise `false` if the viewer will use the height and width values it is given.
  See Also:
    `setBestFitPage`

### isDisplayGroupTree

    public boolean isDisplayGroupTree()

  Returns whether the group tree is displayed.

  Returns:
    `true` if the group tree is displayed and `false` otherwise.
  See Also:
    `setDisplayGroupTree`

### isDisplayPage

    public boolean isDisplayPage()

  Returns whether the report page is displayed.

  Note: If `isDisplayPage` is `false` then `isDisplayToolbar` is also `false`.

  Returns:
    `true` if the report page is displayed and `false` otherwise.
  See Also:
    `setDisplayPage`

### isDisplayToolbar

    public boolean isDisplayToolbar()

  Returns whether the toolbar is displayed.

  Note: If `isDisplayPage` is `false` then `isDisplayToolbar` will also be`false`.

  Returns:
    `true` if the toolbar is displayed and `false` otherwise.
  See Also:
    `setDisplayToolbar`

### isEnableDrillDown

    public boolean isEnableDrillDown()

  Returns whether the user can drill down on the report.

  Returns:
    `true` if the user can drill down on the report and `false` otherwise.
  See Also:
    `setEnableDrillDown`

### isRenderAsHTML32

    public boolean isRenderAsHTML32()

  Returns whether the report is rendered as HTML 3.2.

  Returns:
    true if the report is rendered as HTML 3.2 and `false` otherwise.
  See Also:
    `setRenderAsHTML32`

### isSeparatePages

    public boolean isSeparatePages()

  Returns whether the report is displayed as separate pages or one long page. It is not recommended that you set to this `false` when displaying longer reports as the report will not display until the report has been fully loaded. When set to `false` `searchText` will not be available.

  Returns:
    `true` if the report is displayed as separate pages and `false` otherwise.
  See Also:
    `setSeparatePages`

### isShowAllPageIds

    public boolean isShowAllPageIds()

  Returns whether `PageIds` are added to the HTML content. If page IDs are added to the HTML additional content, they will be added to the beginning of the HTML `div` tags to identify the page.

  Returns:
    `true` if the additional `PageIds` are added to the HTML content and `false` otherwise.
  See Also:
    `setShowAllPageIds`

### removeDrillDownSubreportEventListener

    public void removeDrillDownSubreportEventListener()

  Removes a `DrillDownSubreportEventListener`.

  See Also:
    `addDrillDownSubreportEventListener`

### removeNavigateEventListener

    public void removeNavigateEventListener()

  Removes a `NavigateEventListener`.

  See Also:
    `addNavigateEventListener`

### removeToolbarCommandEventListener

    public void removeToolbarCommandEventListener()

  Removes a `ToolbarCommandEventListener`.

  See Also:
    `addToolbarCommandEventListener`

### searchText

    public void searchText(java.lang.String strTextToSearch,
                           int searchDirection)

  Highlights the first occurrence of the specified text in the report and scrolls to it.

  Note: The text search begins on the following page. To search the first page of a report or to search a report that is displayed continuously (that is, where `setSeparatePages` is set to `false`), you must use the browser's search function.

  Parameters:
    `strTextToSearch` - A `String` that specifies the text string to search for in the report.
    `searchDirection` - An `int` that specifies the search direction. Currently, the only available value is 0 for forward.

### setBestFitPage

    public void setBestFitPage(boolean bestFitPage)

  Sets whether the viewer will ignore the height and width values it is given and try to find the best fit for the report by taking up as much space as it needs to properly display the report.

  Parameters:
    `bestFitPage` - `true` to find the best fit for the report, otherwise `false` to use the height and width values it is given.
  See Also:
    `isBestFitPage`

### setDisplayGroupTree

    public void setDisplayGroupTree(boolean newM_bDisplayGroupTree)

  Sets whether to display the group tree.

  Parameters:
    `newM_bDisplayGroupTree` - `true` to display the group tree.
  See Also:
    `isDisplayGroupTree`

### setDisplayPage

    public void setDisplayPage(boolean newM_bDisplayPage)

  Sets whether to display the report page.

  Parameters:
    `newM_bDisplayPage` - `true` to display the report page.
  See Also:
    `isDisplayPage`

### setDisplayToolbar

    public void setDisplayToolbar(boolean display)

  Sets whether to display the toolbar.

  Parameters:
    `display` - `true` to display the toolbar.
  See Also:
    `isDisplayToolbar`

### setEnableDrillDown

    public void setEnableDrillDown(boolean enableDrillDown)

  Sets whether to enable drill down.

  Parameters:
    `enableDrillDown` - `true` to enable drill down.
  See Also:
    `isEnableDrillDown`

### setGroupTreeWidth

    public void setGroupTreeWidth(int newGroupTreeWidth)

  Sets the width of the group tree. This value can be either be specified in pixels or as a percentage, by passing the appropriate `CrHtmlUnitEnum` object to `setGroupTreeWidthUnit(com.crystaldecisions.report.web.viewer.CrHtmlUnitEnum)`.

  Parameters:
    `newGroupTreeWidth` - An `int` specifying the new width of the group tree.

### setGroupTreeWidthUnit

    public void setGroupTreeWidthUnit(CrHtmlUnitEnum newGroupTreeWidthUnit)

  Sets whether to use pixels or percentage to determine the group tree width.

  Parameters:
    `newGroupTreeWidthUnit` - A `CrHtmlUnitEnum` object specifying the unit to use to determine group tree width.
  See Also:
    `CrHtmlUnitEnum`

### setPrintMode

    public void setPrintMode(CrPrintMode printMode)

  Sets whether to print using PDF or ActiveX print mode when the user clicks the print button. In PDF print mode, a PDF will be displayed, allowing the user to then print it. In ActiveX print mode, an ActiveX control will be downloaded to the client machine and will be printed directly to the user. If ActiveX print mode is selected on a system that does not support ActiveX controls, the print mode will default to PDF printing.

  Parameters:
    `printMode` - A `CrPrintMode` object specifying the print mode to be used.
  See Also:
    `getPrintMode()`

### getPrintMode

    public CrPrintMode getPrintMode()

  Returns the current print mode that will be used when the user clicks the print button.

  Returns:
    A `CrPrintMode` object specifying the print mode currently being used.
  See Also:
    `setPrintMode(com.crystaldecisions.report.web.viewer.CrPrintMode)`

### setHasExportButton

    public void setHasExportButton(boolean newM_bHasExportButton)

  Sets whether to display the export button.

  Note: `setOwnPage` must be set to `true` or the button is not rendered, regardless of the value set in the `setHasExportButton` method.

  Parameters:
    `newM_bHasExportButton` - `true` to display the export button.
  See Also:
    `hasExportButton`

### setHasGotoPageButton

    public void setHasGotoPageButton(boolean newM_bHasGotoPageButton)

  Sets whether to display the `GotoPageButton`.

  Note: If `true`, the HTML returned includes a text box, into which the user can type a page number to navigate to a specific page in the report. If `false`, the HTML returned displays the current page, but does not allow the user to navigate by page number. The default value is `true`.

  Parameters:
    `newM_bHasGotoPageButton` - `true` to display the `GotoPageButton` button.
  See Also:
    `hasGotoPageButton`

### setHasLogo

    public void setHasLogo(boolean newM_bHasLogo)

  Sets whether to display the Crystal Decisions logo.

  Parameters:
    `newM_bHasLogo` - `true` to display the Crystal Decisions logo.
  See Also:
    `hasLogo`

### setHasPageNavigationButtons

    public void setHasPageNavigationButtons(boolean newM_bHasPageNavigationButtons)

  Sets whether to display the page navigation buttons.

  Parameters:
    `newM_bHasPageNavigationButtons` - `true` to display page navigation buttons.
  See Also:
    `hasPageNavigationButtons`

### setHasPrintButton

    public void setHasPrintButton(boolean newM_bHasPrintButton)

  Sets whether to display the print button.

  Note: Printing is accomplished by automatically exporting the report to PDF and then printing the report from the PDF viewer.

  Parameters:
    `newM_bHasPrintButton` - `true` to display the print button.
  See Also:
    `hasPrintButton`

### setHasRefreshButton

    public void setHasRefreshButton(boolean newM_bHasRefreshButton)

  Sets whether to display the refresh button.

  Parameters:
    `newM_bHasRefreshButton` - `true` to display the refresh button.
  See Also:
    `hasRefreshButton`

### setHasSearchButton

    public void setHasSearchButton(boolean newM_bHasSearchButton)

  Sets whether to display the search button.

  Parameters:
    `newM_bHasSearchButton` - `true` to display the search button.
  See Also:
    `hasSearchButton`

### setHasToggleGroupTreeButton

    public void setHasToggleGroupTreeButton(boolean newM_bHasToggleButton)

  Sets whether to display the toggle group tree button.

  Parameters:
    `newM_bHasToggleButton` - `true` to display the toggle button.
  See Also:
    `hasToggleGroupTreeButton`

### setHasViewList

    public void setHasViewList(boolean newM_bHasViewList)

  Sets whether to display the view list.

  Note: The view list will include the Main Report and any views you have drilled-down into. This can include groups, charts and subreports.

  Parameters:
    `newM_bHasViewList` - `true` to display the view list button.
  See Also:
    `hasViewList`

### setHasZoomFactorList

    public void setHasZoomFactorList(boolean newM_bHasZoomButton)

  Sets whether to display a zoom factor list.

  Parameters:
    `newM_bHasZoomButton` - `true` to display a zoom factor list.
  See Also:
    `getZoomFactor`, `hasZoomFactorList`, `setZoomFactor`

### setPageToTreeRatio

    public void setPageToTreeRatio(double newM_nPageToTreeRatio)

  Deprecated. Use `setGroupTreeWidth(int)` and `setGroupTreeWidthUnit(com.crystaldecisions.report.web.viewer.CrHtmlUnitEnum)` instead.

  Sets the page-to-tree ratio. This indicates the percentage of the report viewer that will be used to display the page as compared to the tree.

  Note: The default value for the ratio is 3, which indicates that the page takes up 3 times more space than the tree, or 75 percent of the space.

  Parameters:
    `newM_nPageToTreeRatio` - A `double` that specifies the page-to-tree ratio.
  See Also:
    `getPageToTreeRatio`

### setRenderAsHTML32

    public void setRenderAsHTML32(boolean newM_bRenderAsHTML32)

  Sets whether to render the content as HTML 3.2.

  Parameters:
    `newM_bRenderAsHTML32` - `true` to display the content as HTML 3.2.
  See Also:
    `isRenderAsHTML32`

### setSeparatePages

    public void setSeparatePages(boolean separate)

  Sets whether the report is displayed as separate pages or one long page. It is not recommended that you set to this `false` when displaying longer reports as the report will not display until the report has been fully loaded. When set to `false` `searchText` will not be available.

  Parameters:
    `separate` - `true` if the report is displayed as separate pages.
  See Also:
    `isSeparatePages`

### setShowAllPageIds

    public void setShowAllPageIds(boolean showAllPageIds)

  Sets whether `PageIds` are added to the HTML content. If page IDs are added to the HTML additional content, they will be added to the beginning of the HTML `div` tags to identify the page.

  Parameters:
    `showAllPageIds` - `true` if the additional `PageIds` are added to the HTML content.
  See Also:
    `isShowAllPageIds`

### setZoomFactor

    public void setZoomFactor(int newM_ZoomFactor)

  Sets a new zoom factor for displaying the report. Acceptable values for the zoom factor range from 10 to 400 percent.

  Parameters:
    `newM_ZoomFactor` - An `int` that specifies the value for the zoom factor.
  See Also:
    `getZoomFactor`, `hasZoomFactorList`, `setHasZoomFactorList`

### showFirstPage

    public void showFirstPage()

  Displays the first page of the report.

  See Also:
    `showLastPage`, `showNextPage`, `showNthPage`, `showPreviousPage`

### showLastPage

    public void showLastPage()

  Displays the last page of the report.

  See Also:
    `showFirstPage`, `showNextPage`, `showNthPage`, `showPreviousPage`

### showNextPage

    public void showNextPage()

  Displays the next page of the report.

  Note: If the last page of the report is currently displayed, the viewer remains on this page.

  See Also:
    `showFirstPage`, `showLastPage`, `showNthPage`, `showPreviousPage`

### showNthPage

    public void showNthPage(int pageNumber)

  Displays the specified page of the report.

  Note: If the report has no Nth page, the last page of the report is displayed.

  Parameters:
    `pageNumber` - An `int` that specifies the page of the report to be displayed.
  See Also:
    `showFirstPage`, `showLastPage`, `showNextPage`, `showPreviousPage`

### showPreviousPage

    public void showPreviousPage()

  Displays the previous page of the report.

  Note: If the first page of the report is currently displayed, the viewer remains on this page.

  See Also:
    `showFirstPage`, `showLastPage`, `showNextPage`, `showNthPage`